
/* Copyright (C) 2015 David Eller <david@larosterna.com>
 * 
 * Commercial License Usage
 * Licensees holding valid commercial licenses may use this file in accordance
 * with the terms contained in their respective non-exclusive license agreement.
 * For further information contact david@larosterna.com .
 *
 * GNU General Public License Usage
 * Alternatively, this file may be used under the terms of the GNU General
 * Public License version 3.0 as published by the Free Software Foundation and
 * appearing in the file gpl.txt included in the packaging of this file.
 */
 

// mathematical operators for  SVector<N,NumType>
// file generated by genua/tools/opsprint.py

template <uint N, class NumType>
inline SVector<N,NumType> operator+ (const SVector<N,NumType> & a, const SVector<N,NumType> & b)
{
  SVector<N,NumType> c(a);
  for (uint i=0; i<N; ++i)
    c[i] += b[i];
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> & operator+= (SVector<N,NumType> & a, const SVector<N,NumType> & b)
{
  for (uint i=0; i<N; ++i)
    a[i] += b[i];
  return a;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator+ (const SVector<N,NumType> & a, NumType b)
{
  SVector<N,NumType> c(a);
  for (uint i=0; i<N; ++i)
    c[i] += b;
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> & operator+= (SVector<N,NumType> & a, NumType b)
{
  for (uint i=0; i<N; ++i)
    a[i] += b;
  return a;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator+ (NumType a, const SVector<N,NumType> & b)
{
  SVector<N,NumType> c(b);
  for (uint i=0; i<N; ++i)
    c[i] += a;
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator- (const SVector<N,NumType> & a, const SVector<N,NumType> & b)
{
  SVector<N,NumType> c(a);
  for (uint i=0; i<N; ++i)
    c[i] -= b[i];
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> & operator-= (SVector<N,NumType> & a, const SVector<N,NumType> & b)
{
  for (uint i=0; i<N; ++i)
    a[i] -= b[i];
  return a;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator- (const SVector<N,NumType> & a, NumType b)
{
  SVector<N,NumType> c(a);
  for (uint i=0; i<N; ++i)
    c[i] -= b;
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> & operator-= (SVector<N,NumType> & a, NumType b)
{
  for (uint i=0; i<N; ++i)
    a[i] -= b;
  return a;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator- (NumType a, const SVector<N,NumType> & b)
{
  SVector<N,NumType> c;
  for (uint i=0; i<N; ++i)
    c[i] = a - b[i];
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator* (const SVector<N,NumType> & a, NumType b)
{
  SVector<N,NumType> c(a);
  for (uint i=0; i<N; ++i)
    c[i] *= b;
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> & operator*= (SVector<N,NumType> & a, NumType b)
{
  for (uint i=0; i<a.size(); ++i)
    a[i] *= b;
  return a;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator* (NumType a, const SVector<N,NumType> & b)
{
  SVector<N,NumType> c(b);
  for (uint i=0; i<N; ++i)
    c[i] *= a;
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator/ (const SVector<N,NumType> & a, NumType b)
{
  SVector<N,NumType> c(a);
  NumType ib( NumType(1.0)/b );
  for (uint i=0; i<N; ++i)
    c[i] *= ib;
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> & operator/= (SVector<N,NumType> & a, NumType b)
{
  NumType ib(1.0/b);
  for (uint i=0; i<N; ++i)
    a[i] *= ib;
  return a;
}

template <uint N, class NumType>
inline SVector<N,NumType> operator/ (NumType a, const SVector<N,NumType> & b)
{
  SVector<N,NumType> c;
  for (uint i=0; i<N; ++i)
    c[i] = a / b[i];
  return c;
}

template <uint N, class NumType>
inline SVector<N,NumType> sin(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = sin(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> cos(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = cos(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> tan(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = tan(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> asin(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = asin(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> acos(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = acos(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> atan(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = atan(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> exp(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = exp(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> log(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = log(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> sqrt(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = sqrt(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> ceil(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = ceil(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> floor(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = floor(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> sinh(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = sinh(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> cosh(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = cosh(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> tanh(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = tanh(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> fabs(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = fabs(a[i]);
  return b;
}

template <uint N, class NumType>
inline SVector<N,NumType> log10(const SVector<N,NumType> & a)
{
  SVector<N,NumType> b;
  for (uint i=0; i<N; ++i)
    b[i] = log10(a[i]);
  return b;
}

