
/* ------------------------------------------------------------------------
 * file:       nacellegeometrydlg.h
 * copyright:  (c) 2009 by <david.eller@gmx.net>
 * ------------------------------------------------------------------------
 * Define engine nacelle geometry
 * ------------------------------------------------------------------------ */

#ifndef SUMO_NACELLEGEOMETRYDLG_H
#define SUMO_NACELLEGEOMETRYDLG_H

#include <QDialog>

namespace Ui {
    class NacelleGeometryDlg;
}

class BodySkeleton;

/** Define geometry parameters specific for nacelles.
  */
class NacelleGeometryDlg : public QDialog
{
  Q_OBJECT

  public:

    /// create widget
    NacelleGeometryDlg(QWidget *parent, BodySkeleton & b);

    /// destroy widget
    ~NacelleGeometryDlg();

    /// query whether any dialog of this type is visible
    static bool showing() {return bShown;}

  Q_SIGNALS:

    /// emitted when geometry was modified
    void geometryChanged();

  private Q_SLOTS:

    /// apply changes to body
    void apply();

  protected:

    /// retranslate etc.
    void changeEvent(QEvent *e);

  private:

    /// body object to modify
    BodySkeleton & body;

    /// autogenerated UI object
    Ui::NacelleGeometryDlg *m_ui;

    /// currently shown or not?
    static bool bShown;
};

#endif // NACELLEGEOMETRYDLG_H
